﻿init -81 python:
    try:
        mmm.add(
            gui0_menu(
                _("Credits"),
                ShowMenu("credits"),
                False, False, True
                ),
            )
    except:
        pass

init python:
    class credits_class:
        def __init__(self):
            self.animation_speeed = 2
        def show(self, time, *args):
            items = []
            item = []
            for i in args:
                if isinstance(i, list):
                    items.append(i)
                else:
                    if len(item):
                        item.append(i)
                        items.append(item)
                        item = []
                    else:
                        item.append("text")
                        item.append(i)
            tag = "cred_{}".format(renpy.random.randint(999, 99999))
            renpy.call_screen("cred_ins", time = time, items = items, speed = self.animation_speeed, tag = tag, _tag = tag)
            
 
# ----------------------------- the animation
transform cred_trans(speed, p, d=renpy.random.random()):
    subpixel True
    alpha 0 zoom 0
    pause d
    parallel:
        ease_bounce speed/2 zoom 1
        pause p+speed-d
        ease speed/2 zoom 0
    parallel:
        linear speed alpha 1
        pause p-d
        ease_quart speed alpha 0


# ----------------------------- define a credit list
default credit = credits_class()

screen cred_ins(time, items, speed, tag):
    style_prefix "credits"
    timer time+4 action Return()
    frame:
        xfill True yfill True margin 100,100 background None
        vbox:
            spacing 40 align .5,.5
            for x in items:
                if x[0] == "text":
                    text x[1] at cred_trans(speed, time) size x[2]
                # elif x[0] == "action":
                #     timer items[0] action x[1]
                elif x[0] == "button":
                    button:
                        at cred_trans(speed, time)
                        text x[1]
                        action x[2]
                elif x[0] == "screen":
                    use expression x[1] pass (speed, time)

style credits_button:
    background "#fff9"
    padding (20,20)




label credits_example:
    scene
    show bg
    pause 1
    show image "#101e" with dissolve
    $ credit.show( 4, # Duration
        "0GUI credits example", 50 # Text, size, text, size, etc..
    )
    $ credit.show( 4,
        "Background art by", 50,
        "Uncle Mugen", 30,
    )
    $ credit.show( 4,
        "Story  by", 50,
        "KiaAzad \"Not a story per se.\"", 30,
    )
    $ credit.show( 4,
        "Music by", 50,
        "Nobody \"We don't have em yet!\"", 30,
        "SFX by \"KiaAzad\"", 30,
    )
    $ credit.show( 4,
        "Programming by", 50,
        "KiaAzad", 30,
    )
    $ credit.show( 4,
        "GUI design by", 50,
        "KiaAzad", 30,
    )
    $ credit.show( 4,
        "Special thanks to our Patreon supporters", 50,
        "light day, Comic2k, J. Webb, Quarak, Joseph Regan, El Ciclo, Lady Isak, Julia Spars, MCCOA, Alcantara B. Jeremy, Cruset, Michael Emerson, SLimGames, Senpai, Mangoku418, MichiS, Edward, DJ Johnson, Adeptus Celeng, Neo (Pablo Cidade), Xion Neko, D.S.-sama, Lodge of Dreamers, The Typist, MoolahMilk, Francisco Manitas, izan husnandar, Alex Crowder, Simplify6, ddfunlol, Wrenilations, Aldo Misael Campos, Joanna B, Crypto, Roland Kornis, Pi3shark, Cait Rose, Jamego, Rose, Sarin Khoonjun, rockytheguy, Madison Siercke, steveo, Jingyu Chen, Sumooli Island Inc., Patrick Bowers, division tank, Jessamin, Benjamin Melendrez", 30,
        "And many more", 30,
    )
    $ credit.show( 5,
        "These 3 images:", 60,
        ["screen", "credits_images"] # Screens / images example
    )
    $ credit.show( 10,
        "Thank you for using 0GUI.", 60,
        ["button", "Return", Return()] # Button example ["type", "text", action]
    )
    
    # This is no longer needed, however, it can be added back for special uses
    # $ credit.show( 2,
    #     ["action", Return()], # Action example ["type", action]
    # )

    return # if you use call, this will return you where you were

screen credits_images(speed, time):
    hbox:
        spacing 20
        add "portrait_1" at cred_trans(speed, time)
        add "portrait_2" at cred_trans(speed, time)
        add "portrait_3" at cred_trans(speed, time)

